' Example 2a:   Write some misc application data to a SmartDongle.
'
' MicroWorks, Inc.
' 2808 North Cole Road
' Boise, ID 83704
'
' http://www.smartdongle.com

Imports System

Module Example2a

    Sub Main()

        Dim dongle As New SmartDongle()
        Dim P1 As Int64, P2 As Int64
        Dim dnglError As SmartDongle.SmartDnglError
        Dim address As Int16
        Dim buffer() As Byte
        Dim str As String = New String(c:=Convert.ToChar(&H0), count:=32)
        Dim yourData As String
        Dim encoding As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()


        ' Some application data
        yourData = "This is data written to the SmartDongle, it can be serial numbers, program parameters, etc.  Note that this data can be read by observing activity on the USB bus. Refer to Example3a.vb and Example3b.vb for example of encrypting your application data."

        '  Your keys here
        P1 = &HEC6CC589AEFD1E75
        P2 = &HFCEC0A6A82747B3F

        ' Write a Byte array at begining of SmartDongle user memory.
        '
        ' Note: The number of writes is limited, SmartDongle uses a Catalyst
        '       CAT25C256 SPI eprom, which has a life expectancy of approximately
        '       1 Million writes.  Unlimited reads, of course.
        '
        buffer = New Byte(yourData.Length) {}
        buffer = encoding.GetBytes(yourData)
        address = 0 ' User memory address. Byte addressable from 0 to 32431
        dnglError = dongle.Write(P1, P2, address, buffer, buffer.Length)
        If dnglError = SmartDongle.SmartDnglError.UskOk Then

            System.Console.WriteLine("Success: Wrote application data to SmartDongle")
        Else

            System.Console.WriteLine("Failed: Could not write application data to SmartDongle")
            System.Console.WriteLine(SmartDongle.GetErrorString(dnglError))

            ' handle error
        End If

        System.Console.WriteLine("")
        System.Console.WriteLine("Press <Enter> to Exit")
        System.Console.ReadLine()
    End Sub

End Module
