' Example 2b: Verify a secret stored on a SmartDongle.
'
' MicroWorks, Inc.
' 2808 North Cole Road
' Boise, ID 83704
'
' http://www.smartdongle.com

Imports System

Module Example2b

    Sub Main()

        Dim dongle As New SmartDongle()
        Dim P1 As Int64, P2 As Int64
        Dim dnglError As SmartDongle.SmartDnglError
        Dim address As Int16
        Dim buffer() As Byte
        Dim str As String = New String(c:=Convert.ToChar(&H0), count:=32)
        Dim yourData As String
        Dim yourDataBytes() As Byte
        Dim encoding As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()
        Dim i As Integer


        ' This is the application data you are looking for from Example 2A
        yourData = "This is data written to the SmartDongle, it can be serial numbers, program parameters, etc.  Note that this data can be read by observing activity on the USB bus. Refer to Example3a.vb and Example3b.vb for example of encrypting your application data."

        '  Your keys here
        P1 = &HEC6CC589AEFD1E75
        P2 = &HFCEC0A6A82747B3F

        ' Read SmartDongle user memory into a Byte array.
        buffer = New Byte(yourData.Length) {}
        address = 0 ' User memory address. Byte addressable from 0 to 32431
        dnglError = dongle.Read(P1, P2, address, buffer, yourData.Length)
        If dnglError <> SmartDongle.SmartDnglError.UskOk Then
            System.Console.WriteLine(SmartDongle.GetErrorString(dnglError))
            ' handle error
        End If

        yourDataBytes = encoding.GetBytes(yourData)

        ' As an exercise, simply comparing data read from SmartDongle to
        ' the expected user data.  A developer could do any number of
        ' tricks with the data here.
        For i = 1 To yourDataBytes.Length - 1
            If (buffer(i) <> yourDataBytes(i)) Then
                System.Console.WriteLine("Failed: Invalid Application Data")
                Exit For
            End If
        Next

        If i = yourDataBytes.Length Then
            System.Console.WriteLine("Success: Found Valid Application Data")
        End If

        System.Console.WriteLine("")
        System.Console.WriteLine("Press <Enter> to Exit")
        System.Console.ReadLine()

    End Sub

End Module
